image: docker:stable
services: 
  - docker:dind

variables:
  SERVER_PORT: 10101
  MAVEN_OPTS: "-Dmaven.repo.local=.m2/repository -Dorg.slf4j.simpleLogger.log.org.apache.maven.cli.transfer.Slf4jMavenTransferListener=WARN -Dorg.slf4j.simpleLogger.showDateTime=true -Djava.awt.headless=true"
  MAVEN_CLI_OPTS: "-s .m2/settings.xml --batch-mode --errors --fail-at-end --show-version -DinstallAtEnd=true -DdeployAtEnd=true"

stages:
  - test
  - version
  - build
  - package
  - deploy
  
demo-test:
  image: maven:3-jdk-8-alpine
  stage: test
  before_script:
    - mkdir -p ./.m2
    - cp ArtifactorySettings.xml ./.m2/settings.xml
  script:
    - mvn clean org.jacoco:jacoco-maven-plugin:prepare-agent install -Dmaven.test.failure.ignore=false package sonar:sonar -Dsonar.host.url=http://sonarqube.batm.world -Dsonar.projectName=Demo-${GITLAB_USER_LOGIN}-${CI_COMMIT_REF_NAME} ${MAVEN_CLI_OPTS}
  tags:
    - dind
  retry:
    max: 2
    when:
      - runner_system_failure
      - stuck_or_timeout_failure
 
# tag-version:
#   image: alaksmana/semver:latest
#   before_script:
#     - mkdir -p ~/.ssh
#     - chmod 700 ~/.ssh
#     - eval $(ssh-agent -s)
#     - echo "$CI_DEPLOY_PRIVATE_KEY"
#     - echo "$CI_DEPLOY_PRIVATE_KEY" | tr -d '\r' | ssh-add - > /dev/null
#     - echo "$CI_DEPLOY_KNOWN_HOSTS" > ~/.ssh/known_hosts
#     - chmod 644 ~/.ssh/known_hosts
#     - echo "$CI_DEPLOY_PRIVATE_KEY" > ~/.ssh/id_rsa
#     - chmod 700 ~/.ssh/id_rsa
#     - ls ~/.ssh
#   stage: version
#   script: 
#     # Get version, exit early if tag already exists
#     - export SEMVER_LAST_TAG=$(git describe --abbrev=0 --tags 2>/dev/null)
#     - export SEMVER_RELEASE_LEVEL=$(git log --oneline -1 --pretty=%B | cat | tr -d '\n' | cut -d "[" -f2 | cut -d "]" -f1)
#     - if [ -z $SEMVER_LAST_TAG ]; then >&2 echo "No tags defined"; SEMVER_LAST_TAG="0.0.0"; fi
#     - if [ -n $SEMVER_RELEASE_LEVEL ]; then >&2 echo "Release level ";echo $SEMVER_RELEASE_LEVEL;else >&2 echo "No release level defined, [patch] will be used."; export SEMVER_RELEASE_LEVEL=patch; fi
#     - export SEMVER_VERSION=$(/opt/semver-tool.sh bump $SEMVER_RELEASE_LEVEL $SEMVER_LAST_TAG)
#     - git tag
#     - echo $SEMVER_VERSION
#     - export SEMVER_VERSION_TAG_EXISTS=$(git tag | grep $SEMVER_VERSION | wc -l)
#     - test $SEMVER_VERSION_TAG_EXISTS -eq 1 && exit 0 # exit early if the version tag already exists
#     # Push new tag
#     - export SEMVER_REMOTE_EXIST=$(git remote | grep gitlab)
#     - if [ -z $SEMVER_REMOTE_EXIST]; then >&2 echo "No remote gitlab defined"; git remote add gitlab "$SEMVER_REPO_URL";else >&2 echo "Remote gitlab defined, removing it"; git remote remove gitlab; git remote add gitlab "$SEMVER_REPO_URL"; fi        
#     - git config --global user.name "$REG_USER"
#     - git config --global user.email "$REG_USER_EMAIL"
#     - git remote set-url origin ssh://git@192.168.0.51:8022/${CI_PROJECT_PATH}.git
#     - git remote -v
#     # - git fetch gitlab
#     - git tag $SEMVER_VERSION
#     - git push origin $SEMVER_VERSION
#   only:
#     - master
#   tags:
#     - master
#   retry:
#     max: 2
#     when:
#       - runner_system_failure
#       - stuck_or_timeout_failure  

demo-build:
  image: maven:3-jdk-8-alpine
  stage: build
  before_script:
    - mkdir -p ./.m2
    - cp ArtifactorySettings.xml ./.m2/settings.xml
  script: 
    - mvn package -Dmaven.test.skip=true $MAVEN_CLI_OPTS
  artifacts:
    paths:
      - ./target/*.jar
  # only:
  #   - tags
  tags:
    - dind
  retry:
    max: 2
    when:
      - runner_system_failure
      - stuck_or_timeout_failure

demo-package:
  stage: package
  script:
    - chmod +x entrypoint.sh
    - docker build --cache-from ${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_NAME} -t ${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_NAME} .    
    - docker push ${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_NAME}
    - docker tag ${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_NAME} ${CI_REGISTRY_IMAGE}:latest
    - docker push ${CI_REGISTRY_IMAGE}:latest
  # only:
  #   - tags
  tags:
    - dind
  retry:
    max: 2
    when:
      - runner_system_failure
      - stuck_or_timeout_failure

demo-docker-deploy:
  stage: deploy
  script:
    - docker pull ${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_NAME}
    - docker run --name demo -d --rm -p ${SERVER_PORT}:8080 demo:${CI_COMMIT_REF_NAME}
  # only:
  #   - tags
  tags:
    - my-dind
  retry:
    max: 2
    when:
      - runner_system_failure
      - stuck_or_timeout_failure
